Attribute VB_Name = "ModFonctionsDiverses"
Option Explicit

Public Function AireEtSensDeRotationDuPolygone(Points() As VertexOpenGL) As Double
   Dim NbrePoints As Long, i As Long, j As Long
   Dim AireFoisDeux As Double
   
   ' ***** Dtermination de l'aire d'un polygone ET du sens de rotation **********
   ' ***** ATTENTION : le premier et le dernier point doivent tre confondus *****
   ' ***** Principe sur http://alienryderflex.com/polygon_area/ ******************
   '     P4(4,4) + P0(4,4)
   '
   '   P3(2,2)+
   '                + P1(5,1)
   '            + P2(3,0)
   ' Index du tableau de 0  4 avec le premier et le dernier points confondus.
   ' i varie de 0  3 et j de 1  4, on calcule l'aire  gauche du segment (*2) qui est positive quand les Y descendent et ngative quand ils montent.
   
   ' L'aire obtenue est positive si on tourne dans le sens de aiguilles d'une montre et ngative si on tourne dans le sens trigo.
   ' => la fonction permet aussi de dterminer le sens de rotation.
   
   AireFoisDeux = 0
   For i = LBound(Points) To UBound(Points) - 1
      j = i + 1
      AireFoisDeux = AireFoisDeux + (Points(i).x + Points(j).x) * (Points(i).y - Points(j).y)
   Next i
   AireEtSensDeRotationDuPolygone = AireFoisDeux * 0.5
End Function
