Attribute VB_Name = "ModOpenGLFreeGlut"
Option Explicit
'***************************************************************************************
'*                              Module openGL pour freeglut
'***************************************************************************************
' v0.1 - 04/11/2009
'***************************************************************************************
' http://arkham46.developpez.com
'***************************************************************************************
' Documentation freeglut :
' http://freeglut.sourceforge.net/docs/api.php
'***************************************************************************************
'*                                       API                                           *
'***************************************************************************************
Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
' Initialization Functions
Public Declare Sub glutInit Lib "freeglut" (a As Long, b As String)
Public Declare Sub glutInitWindowPosition Lib "freeglut" (ByVal x As Long, ByVal y As Long)
Public Declare Sub glutInitWindowSize Lib "freeglut" (ByVal width As Long, ByVal height As Long)
Public Declare Sub glutInitDisplayMode Lib "freeglut" (ByVal mode As Long)
Public Declare Sub glutInitDisplayString Lib "freeglut" (ByVal str As String)
' Event Processing Functions
Public Declare Sub glutMainLoop Lib "freeglut" ()
Public Declare Sub glutMainLoopEvent Lib "freeglut" ()
Public Declare Sub glutLeaveMainLoop Lib "freeglut" ()
' Window Functions
Public Declare Function glutCreateWindow Lib "freeglut" (ByVal title As String) As Long
Public Declare Function glutCreateSubWindow Lib "freeglut" (ByVal win As Long, ByVal x As Long, ByVal y As Long, _
                    ByVal width As Long, ByVal height As Long) As Long
Public Declare Sub glutDestroyWindow Lib "freeglut" (ByVal win As Long)
Public Declare Sub glutSetWindow Lib "freeglut" (ByVal win As Long)
Public Declare Function glutGetWindow Lib "freeglut" () As Long
Public Declare Sub glutSetWindowTitle Lib "freeglut" (ByVal title As String)
Public Declare Sub glutSetIconTitle Lib "freeglut" (ByVal title As String)
Public Declare Sub glutReshapeWindow Lib "freeglut" (ByVal width As Long, ByVal height As Long)
Public Declare Sub glutPositionWindow Lib "freeglut" (ByVal x As Long, ByVal y As Long)
Public Declare Sub glutShowWindow Lib "freeglut" ()
Public Declare Sub glutHideWindow Lib "freeglut" ()
Public Declare Sub glutIconifyWindow Lib "freeglut" ()
Public Declare Sub glutPushWindow Lib "freeglut" ()
Public Declare Sub glutPopWindow Lib "freeglut" ()
Public Declare Sub glutFullScreen Lib "freeglut" ()
' Display Functions
Public Declare Sub glutPostRedisplay Lib "freeglut" ()
Public Declare Sub glutPostWindowRedisplay Lib "freeglut" ()
Public Declare Sub glutSwapBuffers Lib "freeglut" ()
' Mouse Cursor Functions
Public Declare Sub glutSetCursor Lib "freeglut" (ByVal cursor As Long)
Public Declare Sub glutWarpPointer Lib "freeglut" (ByVal x As Long, ByVal y As Long)
' Menu Functions
Public Declare Function glutCreateMenu Lib "freeglut" (ByVal fnPtr As Long) As Long
Public Declare Sub glutDestroyMenu Lib "freeglut" (ByVal menu As Long)
Public Declare Function glutGetMenu Lib "freeglut" () As Long
Public Declare Sub glutSetMenu Lib "freeglut" (ByVal menu As Long)
Public Declare Sub glutAddMenuEntry Lib "freeglut" (ByVal name As String, ByVal val As Long)
Public Declare Sub glutAddSubMenu Lib "freeglut" (ByVal label As String, ByVal submenu As Long)
Public Declare Sub glutChangeToMenuEntry Lib "freeglut" (ByVal item As Long, ByVal label As String, ByVal val As Long)
Public Declare Sub glutChangeToSubMenu Lib "freeglut" (ByVal item As Long, ByVal label As String, ByVal submenu As Long)
Public Declare Sub glutRemoveMenuItem Lib "freeglut" (ByVal item As Long)
Public Declare Sub glutAttachMenu Lib "freeglut" (ByVal button As Long)
Public Declare Sub glutDetachMenu Lib "freeglut" (ByVal button As Long)
' Global Callback Registration Functions
Public Declare Sub glutTimerFunc Lib "freeglut" (ByVal millis As Long, ByVal fnPtr As Long, ByVal val As Long)
Public Declare Sub glutIdleFunc Lib "freeglut" (ByVal fnPtr As Long)
' Window-Specific Callback Registration Functions
Public Declare Sub glutDisplayFunc Lib "freeglut" (ByVal fnPtr As Long)
Public Declare Sub glutReshapeFunc Lib "freeglut" (ByVal fnPtr As Long)
Public Declare Sub glutCloseFunc Lib "freeglut" (ByVal fnPtr As Long)
Public Declare Sub glutKeyboardFunc Lib "freeglut" (ByVal fnPtr As Long)
Public Declare Sub glutSpecialFunc Lib "freeglut" (ByVal fnPtr As Long)
Public Declare Sub glutKeyboardUpFunc Lib "freeglut" (ByVal fnPtr As Long)
Public Declare Sub glutSpecialUpFunc Lib "freeglut" (ByVal fnPtr As Long)
Public Declare Sub glutMouseFunc Lib "freeglut" (ByVal fnPtr As Long)
Public Declare Sub glutMotionFunc Lib "freeglut" (ByVal fnPtr As Long)
Public Declare Sub glutPassiveMotionFunc Lib "freeglut" (ByVal fnPtr As Long)
Public Declare Sub glutJoystickFunc Lib "freeglut" (ByVal fnPtr As Long, ByVal pollInterval As Long)
Public Declare Sub glutMouseWheelFunc Lib "freeglut" (ByVal fnPtr As Long)
Public Declare Sub glutButtonBoxFunc Lib "freeglut" (ByVal fnPtr As Long)
' State Setting and Retrieval Functions
Public Declare Sub glutSetOption Lib "freeglut" (ByVal op As Long, ByVal val As Long)
Public Declare Function glutGet Lib "freeglut" (ByVal typ As Long) As Long
Public Declare Function glutDeviceGet Lib "freeglut" (ByVal typ As Long) As Long
Public Declare Function glutGetModifiers Lib "freeglut" () As Long
Public Declare Function glutLayerGet Lib "freeglut" (ByVal typ As Long) As Long
Public Declare Function glutExtensionSupported Lib "freeglut" (ByVal typ As String) As Long
Public Declare Sub glutSetKeyRepeat Lib "freeglut" (ByVal repeatMode As Long)
Public Declare Sub glutIgnoreKeyRepeat Lib "freeglut" (ByVal ignore As Long)
' Font Rendering Functions
Public Declare Sub glutBitmapCharacter Lib "freeglut" (ByVal font As Long, ByVal character As Long)
Public Declare Sub glutBitmapString Lib "freeglut" (ByVal font As Long, ByVal str As String)
Public Declare Function glutBitmapWidth Lib "freeglut" (ByVal font As Long, ByVal character As Long) As Long
Public Declare Function glutBitmapLength Lib "freeglut" (ByVal font As Long, ByVal str As String) As Long
Public Declare Function glutBitmapHeight Lib "freeglut" (ByVal font As Long) As Long
Public Declare Sub glutStrokeCharacter Lib "freeglut" (ByVal font As Long, ByVal character As Long)
Public Declare Sub glutStrokeString Lib "freeglut" (ByVal font As Long, ByVal str As String)
Public Declare Function glutStrokeWidth Lib "freeglut" (ByVal font As Long, ByVal character As Long) As Long
Public Declare Function glutStrokeLength Lib "freeglut" (ByVal font As Long, ByVal str As String) As Long
Public Declare Function glutStrokeHeight Lib "freeglut" (ByVal font As Long) As Long
' Geometric Object Rendering Functions
Public Declare Sub glutWireSphere Lib "freeglut" (ByVal dRadius As Double, ByVal slices As Long, ByVal stacks As Long)
Public Declare Sub glutSolidSphere Lib "freeglut" (ByVal dRadius As Double, ByVal slices As Long, ByVal stacks As Long)
Public Declare Sub glutWireTorus Lib "freeglut" (ByVal dInnerRadius As Double, ByVal dOuterRadius As Double, ByVal slices As Long, ByVal nRings As Long)
Public Declare Sub glutSolidTorus Lib "freeglut" (ByVal dInnerRadius As Double, ByVal dOuterRadius As Double, ByVal slices As Long, ByVal nRings As Long)
Public Declare Sub glutWireCone Lib "freeglut" (ByVal base As Double, ByVal height As Double, ByVal slices As Long, ByVal stacks As Long)
Public Declare Sub glutSolidCone Lib "freeglut" (ByVal base As Double, ByVal height As Double, ByVal slices As Long, ByVal stacks As Long)
Public Declare Sub glutWireCube Lib "freeglut" (ByVal Size As Double)
Public Declare Sub glutSolidCube Lib "freeglut" (ByVal Size As Double)
Public Declare Sub glutWireTetrahedron Lib "freeglut" ()
Public Declare Sub glutSolidTetrahedron Lib "freeglut" ()
Public Declare Sub glutWireOctahedron Lib "freeglut" ()
Public Declare Sub glutSolidOctahedron Lib "freeglut" ()
Public Declare Sub glutWireDodecahedron Lib "freeglut" ()
Public Declare Sub glutSolidDodecahedron Lib "freeglut" ()
Public Declare Sub glutWireIcosahedron Lib "freeglut" ()
Public Declare Sub glutSolidIcosahedron Lib "freeglut" ()
Public Declare Sub glutWireRhombicDodecahedron Lib "freeglut" ()
Public Declare Sub glutSolidRhombicDodecahedron Lib "freeglut" ()
Public Declare Sub glutWireTeapot Lib "freeglut" (ByVal Size As Double)
Public Declare Sub glutSolidTeapot Lib "freeglut" (ByVal Size As Double)
' Game mode function
Public Declare Sub glutGameModeString Lib "freeglut" (ByVal mode As String)
Public Declare Sub glutEnterGameMode Lib "freeglut" ()
Public Declare Sub glutLeaveGameMode Lib "freeglut" ()
Public Declare Function glutGameModeGet Lib "freeglut" (ByVal eWhat As Long) As Long
'***************************************************************************************
'*                                    Constantes                                       *
'***************************************************************************************
Public Const GLUT_KEY_F1 = &H1&
Public Const GLUT_KEY_F2 = &H2&
Public Const GLUT_KEY_F3 = &H3&
Public Const GLUT_KEY_F4 = &H4&
Public Const GLUT_KEY_F5 = &H5&
Public Const GLUT_KEY_F6 = &H6&
Public Const GLUT_KEY_F7 = &H7&
Public Const GLUT_KEY_F8 = &H8&
Public Const GLUT_KEY_F9 = &H9&
Public Const GLUT_KEY_F10 = &HA&
Public Const GLUT_KEY_F11 = &HB&
Public Const GLUT_KEY_F12 = &HC&
Public Const GLUT_KEY_LEFT = &H64&
Public Const GLUT_KEY_UP = &H65&
Public Const GLUT_KEY_RIGHT = &H66&
Public Const GLUT_KEY_DOWN = &H67&
Public Const GLUT_KEY_PAGE_UP = &H68&
Public Const GLUT_KEY_PAGE_DOWN = &H69&
Public Const GLUT_KEY_HOME = &H6A&
Public Const GLUT_KEY_END = &H6B&
Public Const GLUT_KEY_INSERT = &H6C&

Public Const GLUT_LEFT_BUTTON = &H0&
Public Const GLUT_MIDDLE_BUTTON = &H1&
Public Const GLUT_RIGHT_BUTTON = &H2&
Public Const GLUT_DOWN = &H0&
Public Const GLUT_UP = &H1&
Public Const GLUT_LEFT = &H0&
Public Const GLUT_ENTERED = &H1&

Public Const GLUT_RGB = &H0&
Public Const GLUT_RGBA = &H0&
Public Const GLUT_INDEX = &H1&
Public Const GLUT_SINGLE = &H0&
Public Const GLUT_DOUBLE = &H2&
Public Const GLUT_ACCUM = &H4&
Public Const GLUT_ALPHA = &H8&
Public Const GLUT_DEPTH = &H10&
Public Const GLUT_STENCIL = &H20&
Public Const GLUT_MULTISAMPLE = &H80&
Public Const GLUT_STEREO = &H100&
Public Const GLUT_LUMINANCE = &H200&

Public Const GLUT_MENU_NOT_IN_USE = &H0&
Public Const GLUT_MENU_IN_USE = &H1&
Public Const GLUT_NOT_VISIBLE = &H0&
Public Const GLUT_VISIBLE = &H1&
Public Const GLUT_HIDDEN = &H0&
Public Const GLUT_FULLY_RETAINED = &H1&
Public Const GLUT_PARTIALLY_RETAINED = &H2&
Public Const GLUT_FULLY_COVERED = &H3&

Public Const GLUT_STROKE_ROMAN = 0
Public Const GLUT_STROKE_MONO_ROMAN = 1
Public Const GLUT_BITMAP_9_BY_15 = 2
Public Const GLUT_BITMAP_8_BY_13 = 3
Public Const GLUT_BITMAP_TIMES_ROMAN_10 = 4
Public Const GLUT_BITMAP_TIMES_ROMAN_24 = 5
Public Const GLUT_BITMAP_HELVETICA_10 = 6
Public Const GLUT_BITMAP_HELVETICA_12 = 7
Public Const GLUT_BITMAP_HELVETICA_18 = 8

Public Const GLUT_WINDOW_X = &H64&
Public Const GLUT_WINDOW_Y = &H65&
Public Const GLUT_WINDOW_WIDTH = &H66&
Public Const GLUT_WINDOW_HEIGHT = &H67&
Public Const GLUT_WINDOW_BUFFER_SIZE = &H68&
Public Const GLUT_WINDOW_STENCIL_SIZE = &H69&
Public Const GLUT_WINDOW_DEPTH_SIZE = &H6A&
Public Const GLUT_WINDOW_RED_SIZE = &H6B&
Public Const GLUT_WINDOW_GREEN_SIZE = &H6C&
Public Const GLUT_WINDOW_BLUE_SIZE = &H6D&
Public Const GLUT_WINDOW_ALPHA_SIZE = &H6E&
Public Const GLUT_WINDOW_ACCUM_RED_SIZE = &H6F&
Public Const GLUT_WINDOW_ACCUM_GREEN_SIZE = &H70&
Public Const GLUT_WINDOW_ACCUM_BLUE_SIZE = &H71&
Public Const GLUT_WINDOW_ACCUM_ALPHA_SIZE = &H72&
Public Const GLUT_WINDOW_DOUBLEBUFFER = &H73&
Public Const GLUT_WINDOW_RGBA = &H74&
Public Const GLUT_WINDOW_PARENT = &H75&
Public Const GLUT_WINDOW_NUM_CHILDREN = &H76&
Public Const GLUT_WINDOW_COLORMAP_SIZE = &H77&
Public Const GLUT_WINDOW_NUM_SAMPLES = &H78&
Public Const GLUT_WINDOW_STEREO = &H79&
Public Const GLUT_WINDOW_CURSOR = &H7A&

Public Const GLUT_SCREEN_WIDTH = &HC8&
Public Const GLUT_SCREEN_HEIGHT = &HC9&
Public Const GLUT_SCREEN_WIDTH_MM = &HCA&
Public Const GLUT_SCREEN_HEIGHT_MM = &HCB&
Public Const GLUT_MENU_NUM_ITEMS = &H12C&
Public Const GLUT_DISPLAY_MODE_POSSIBLE = &H190&
Public Const GLUT_INIT_WINDOW_X = &H1F4&
Public Const GLUT_INIT_WINDOW_Y = &H1F5&
Public Const GLUT_INIT_WINDOW_WIDTH = &H1F6&
Public Const GLUT_INIT_WINDOW_HEIGHT = &H1F7&
Public Const GLUT_INIT_DISPLAY_MODE = &H1F8&
Public Const GLUT_ELAPSED_TIME = &H2BC&
Public Const GLUT_WINDOW_FORMAT_ID = &H7B&
Public Const GLUT_INIT_STATE = &H7C&

Public Const GLUT_HAS_KEYBOARD = &H258&
Public Const GLUT_HAS_MOUSE = &H259&
Public Const GLUT_HAS_SPACEBALL = &H25A&
Public Const GLUT_HAS_DIAL_AND_BUTTON_BOX = &H25B&
Public Const GLUT_HAS_TABLET = &H25C&
Public Const GLUT_NUM_MOUSE_BUTTONS = &H25D&
Public Const GLUT_NUM_SPACEBALL_BUTTONS = &H25E&
Public Const GLUT_NUM_BUTTON_BOX_BUTTONS = &H25F&
Public Const GLUT_NUM_DIALS = &H260&
Public Const GLUT_NUM_TABLET_BUTTONS = &H261&
Public Const GLUT_DEVICE_IGNORE_KEY_REPEAT = &H262&
Public Const GLUT_DEVICE_KEY_REPEAT = &H263&
Public Const GLUT_HAS_JOYSTICK = &H264&
Public Const GLUT_OWNS_JOYSTICK = &H265&
Public Const GLUT_JOYSTICK_BUTTONS = &H266&
Public Const GLUT_JOYSTICK_AXES = &H267&
Public Const GLUT_JOYSTICK_POLL_RATE = &H268&

Public Const GLUT_OVERLAY_POSSIBLE = &H320&
Public Const GLUT_LAYER_IN_USE = &H321&
Public Const GLUT_HAS_OVERLAY = &H322&
Public Const GLUT_TRANSPARENT_INDEX = &H323&
Public Const GLUT_NORMAL_DAMAGED = &H324&
Public Const GLUT_OVERLAY_DAMAGED = &H325&

Public Const GLUT_NORMAL = &H0&
Public Const GLUT_OVERLAY = &H1&

Public Const GLUT_ACTIVE_SHIFT = &H1&
Public Const GLUT_ACTIVE_CTRL = &H2&
Public Const GLUT_ACTIVE_ALT = &H4&

Public Const GLUT_CURSOR_RIGHT_ARROW = &H0&
Public Const GLUT_CURSOR_LEFT_ARROW = &H1&
Public Const GLUT_CURSOR_INFO = &H2&
Public Const GLUT_CURSOR_DESTROY = &H3&
Public Const GLUT_CURSOR_HELP = &H4&
Public Const GLUT_CURSOR_CYCLE = &H5&
Public Const GLUT_CURSOR_SPRAY = &H6&
Public Const GLUT_CURSOR_WAIT = &H7&
Public Const GLUT_CURSOR_TEXT = &H8&
Public Const GLUT_CURSOR_CROSSHAIR = &H9&
Public Const GLUT_CURSOR_UP_DOWN = &HA&
Public Const GLUT_CURSOR_LEFT_RIGHT = &HB&
Public Const GLUT_CURSOR_TOP_SIDE = &HC&
Public Const GLUT_CURSOR_BOTTOM_SIDE = &HD&
Public Const GLUT_CURSOR_LEFT_SIDE = &HE&
Public Const GLUT_CURSOR_RIGHT_SIDE = &HF&
Public Const GLUT_CURSOR_TOP_LEFT_CORNER = &H10&
Public Const GLUT_CURSOR_TOP_RIGHT_CORNER = &H11&
Public Const GLUT_CURSOR_BOTTOM_RIGHT_CORNER = &H12&
Public Const GLUT_CURSOR_BOTTOM_LEFT_CORNER = &H13&
Public Const GLUT_CURSOR_INHERIT = &H64&
Public Const GLUT_CURSOR_NONE = &H65&
Public Const GLUT_CURSOR_FULL_CROSSHAIR = &H66&

Public Const GLUT_RED = &H0&
Public Const GLUT_GREEN = &H1&
Public Const GLUT_BLUE = &H2&

Public Const GLUT_KEY_REPEAT_OFF = &H0&
Public Const GLUT_KEY_REPEAT_ON = &H1&
Public Const GLUT_KEY_REPEAT_DEFAULT = &H2&

Public Const GLUT_JOYSTICK_BUTTON_A = &H1&
Public Const GLUT_JOYSTICK_BUTTON_B = &H2&
Public Const GLUT_JOYSTICK_BUTTON_C = &H4&
Public Const GLUT_JOYSTICK_BUTTON_D = &H8&

Public Const GLUT_GAME_MODE_ACTIVE = &H0&
Public Const GLUT_GAME_MODE_POSSIBLE = &H1&
Public Const GLUT_GAME_MODE_WIDTH = &H2&
Public Const GLUT_GAME_MODE_HEIGHT = &H3&
Public Const GLUT_GAME_MODE_PIXEL_DEPTH = &H4&
Public Const GLUT_GAME_MODE_REFRESH_RATE = &H5&
Public Const GLUT_GAME_MODE_DISPLAY_CHANGED = &H6&

Public Const GLUT_ACTION_ON_WINDOW_CLOSE = &H1F9&
Public Const GLUT_WINDOW_BORDER_WIDTH = &H1FA&
Public Const GLUT_WINDOW_HEADER_HEIGHT = &H1FB&
Public Const GLUT_VERSION = &H1FC&
Public Const GLUT_RENDERING_CONTEXT = &H1FD&
Public Const GLUT_DIRECT_RENDERING = &H1FE&

Public Const GLUT_ACTION_EXIT = 0
Public Const GLUT_ACTION_GLUTMAINLOOP_RETURNS = 1
Public Const GLUT_ACTION_CONTINUE_EXECUTION = 2






