Attribute VB_Name = "ModOpenGLTools"
Option Explicit
'***************************************************************************************
'*           Dclarations pour glu / wgl / gdi32
'*               et autres fonctions utiles
'***************************************************************************************
' v0.2 - 08/11/2009
'***************************************************************************************
'*                                       API                                           *
'***************************************************************************************
' Extensions
Private Declare Function GetModuleFileName Lib "kernel32" Alias "GetModuleFileNameA" _
            (ByVal hModule As Long, ByVal lpFileName As String, ByVal nSize As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal ByteLen As Long)
Private Declare Function VirtualProtect Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flNewProtect As Long, lpflOldProtect As Long) As Long
' Glu32
Public Declare Function gluErrorString Lib "glu32" (ByVal error As Long) As Long
Public Declare Function gluGetString Lib "glu32" (ByVal name As Long) As Long
Public Declare Sub gluOrtho2D Lib "glu32" (ByVal left As Double, ByVal right As Double, ByVal bottom As Double, ByVal top As Double)
Public Declare Sub gluPerspective Lib "glu32" (ByVal fovy As Double, ByVal aspect As Double, ByVal zNear As Double, ByVal zFar As Double)
Public Declare Sub gluPickMatrix Lib "glu32" (ByVal x As Double, ByVal y As Double, ByVal width As Double, ByVal height As Double, viewport As Long)
Public Declare Sub gluLookAt Lib "glu32" (ByVal eyex As Double, ByVal eyey As Double, ByVal eyez As Double, ByVal centerx As Double, ByVal centery As Double, ByVal centerz As Double, ByVal upx As Double, ByVal upy As Double, ByVal upz As Double)
Public Declare Function gluProject Lib "glu32" (ByVal objx As Double, ByVal objy As Double, ByVal objz As Double, modelMatrix As Double, projMatrix As Double, viewport As Long, winx As Double, winy As Double, winz As Double) As Long
Public Declare Function gluUnProject Lib "glu32" (ByVal winx As Double, ByVal winy As Double, ByVal winz As Double, modelMatrix As Double, projMatrix As Double, viewport As Long, objx As Double, objy As Double, objz As Double) As Long
Public Declare Function gluScaleImage Lib "glu32" (ByVal format As Long, ByVal widthin As Long, ByVal heightin As Long, ByVal typein As Long, datain As Any, ByVal widthout As Long, ByVal heightout As Long, ByVal typeout As Long, dataout As Any) As Long
Public Declare Function gluBuild1DMipmaps Lib "glu32" (ByVal target As Long, ByVal components As Long, ByVal width As Long, ByVal format As Long, ByVal typ As Long, data As Any) As Long
Public Declare Function gluBuild2DMipmaps Lib "glu32" (ByVal target As Long, ByVal components As Long, ByVal width As Long, ByVal height As Long, ByVal format As Long, ByVal typ As Long, data As Any) As Long
Public Declare Function gluNewQuadric Lib "glu32" () As Long
Public Declare Sub gluDeleteQuadric Lib "glu32" (ByVal qobj As Long)
Public Declare Sub gluQuadricNormals Lib "glu32" (ByVal qobj As Long, ByVal normals As Long)
Public Declare Sub gluQuadricTexture Lib "glu32" (ByVal qobj As Long, ByVal textureCoord As Long)
Public Declare Sub gluQuadricOrientation Lib "glu32" (ByVal qobj As Long, ByVal orientation As Long)
Public Declare Sub gluQuadricDrawStyle Lib "glu32" (ByVal qobj As Long, ByVal drawStyle As Long)
Public Declare Sub gluCylinder Lib "glu32" (ByVal qobj As Long, ByVal baseRadius As Double, ByVal topRadius As Double, ByVal height As Double, ByVal slices As Long, ByVal stacks As Long)
Public Declare Sub gluDisk Lib "glu32" (ByVal qobj As Long, ByVal innerRadius As Double, ByVal outerRadius As Double, ByVal slices As Long, ByVal loops As Long)
Public Declare Sub gluPartialDisk Lib "glu32" (ByVal qobj As Long, ByVal innerRadius As Double, ByVal outerRadius As Double, ByVal slices As Long, ByVal loops As Long, ByVal startAngle As Double, ByVal sweepAngle As Double)
Public Declare Sub gluSphere Lib "glu32" (ByVal qobj As Long, ByVal radius As Double, ByVal slices As Integer, ByVal stacks As Integer)
Public Declare Sub gluQuadricCallback Lib "glu32" (ByVal qobj As Long, ByVal which As Long, ByVal fn As Long)
Public Declare Function gluNewTess Lib "glu32" () As Long
Public Declare Sub gluDeleteTess Lib "glu32" (ByVal tess As Long)
Public Declare Sub gluTessBeginPolygon Lib "glu32" (ByVal tess As Long, data As Any)
Public Declare Sub gluTessBeginContour Lib "glu32" (ByVal tess As Long)
Public Declare Sub gluTessVertex Lib "glu32" (ByVal tess As Long, coords As Double, data As Any)
Public Declare Sub gluTessEndContour Lib "glu32" (ByVal tess As Long)
Public Declare Sub gluTessEndPolygon Lib "glu32" (ByVal tess As Long)
Public Declare Sub gluTessProperty Lib "glu32" (ByVal tess As Long, ByVal which As Long, ByVal value As Double)
Public Declare Sub gluTessNormal Lib "glu32" (ByVal tess As Long, ByVal x As Double, ByVal y As Double, ByVal z As Double)
Public Declare Sub gluTessCallback Lib "glu32" (ByVal tess As Long, ByVal which As Long, ByVal fn As Long)
Public Declare Sub gluGetTessProperty Lib "glu32" (ByVal tess As Long, ByVal which As Long, value As Double)
Public Declare Function gluNewNurbsRenderer Lib "glu32" () As Long
Public Declare Sub gluDeleteNurbsRenderer Lib "glu32" (ByVal nobj As Long)
Public Declare Sub gluBeginSurface Lib "glu32" (ByVal nobj As Long)
Public Declare Sub gluBeginCurve Lib "glu32" (ByVal nobj As Long)
Public Declare Sub gluEndCurve Lib "glu32" (ByVal nobj As Long)
Public Declare Sub gluEndSurface Lib "glu32" (ByVal nobj As Long)
Public Declare Sub gluBeginTrim Lib "glu32" (ByVal nobj As Long)
Public Declare Sub gluEndTrim Lib "glu32" (ByVal nobj As Long)
Public Declare Sub gluPwlCurve Lib "glu32" (ByVal nobj As Long, ByVal count As Long, curvearray As Single, ByVal stride As Long, ByVal typ As Long)
Public Declare Sub gluNurbsCurve Lib "glu32" (ByVal nobj As Long, ByVal nknots As Long, knot As Single, ByVal stride As Long, ctlarray As Single, ByVal order As Long, ByVal typ As Long)
Public Declare Sub gluNurbsSurface Lib "glu32" (ByVal nobj As Long, ByVal sknot_count As Long, sknot As Single, ByVal tknot_count As Long, tknot As Single, ByVal s_stride As Long, ByVal t_stride As Long, ctlarray As Single, ByVal sorder As Long, ByVal torder As Long, ByVal typ As Long)
Public Declare Sub gluLoadSamplingMatrices Lib "glu32" (ByVal nobj As Long, modelMatrix As Single, projMatrix As Single, viewport As Long)
Public Declare Sub gluNurbsProperty Lib "glu32" (ByVal nobj As Long, ByVal property As Long, ByVal value As Single)
Public Declare Sub gluGetNurbsProperty Lib "glu32" (ByVal nobj As Long, ByVal property As Long, value As Single)
Public Declare Sub gluNurbsCallback Lib "glu32" (ByVal nobj As Long, ByVal which As Long, ByVal fn As Long)
Public Declare Sub gluBeginPolygon Lib "glu32" (ByVal tess As Long)
Public Declare Sub gluEndPolygon Lib "glu32" (ByVal tess As Long)
Public Declare Sub gluNextContour Lib "glu32" (ByVal tess As Long, ByVal typ As Long)
' Gdi32
Public Declare Function ChoosePixelFormat Lib "gdi32" (ByVal hdc As Long, ppfd As PIXELFORMATDESCRIPTOR) As Long
Public Declare Function SetPixelFormat Lib "gdi32" (ByVal hdc As Long, ByVal iPixelFormat As Long, ppfd As PIXELFORMATDESCRIPTOR) As Long
Public Declare Function SwapBuffers Lib "gdi32" (ByVal hdc As Long) As Long
' WGL (windows)
Public Declare Function wglCopyContext Lib "opengl32" (ByVal hglrcSrc As Long, ByVal hglrcDst As Long, ByVal mask As Long) As Long
Public Declare Function wglCreateContext Lib "opengl32" (ByVal hdc As Long) As Long
Public Declare Function wglCreateLayerContext Lib "opengl32" (ByVal hglrc As Long, iLayerPlane As Integer) As Long
Public Declare Function wglDeleteContext Lib "opengl32" (ByVal hglrc As Long) As Long
Public Declare Function wglGetCurrentContext Lib "opengl32" () As Long
Public Declare Function wglGetCurrentDC Lib "opengl32" () As Long
Public Declare Function wglGetProcAddress Lib "opengl32.dll" (ByVal lpStr As String) As Long
Public Declare Function wglMakeCurrent Lib "opengl32" (ByVal hdc As Long, ByVal hglrc As Long) As Long
Public Declare Function wglShareLists Lib "opengl32" (ByVal hglrcSrc As Long, ByVal hglrcDst As Long) As Long
Public Declare Function wglUseFontBitmaps Lib "opengl32" Alias "wglUseFontBitmapsA" (ByVal hdc As Long, ByVal first As Long, ByVal count As Long, ByVal listbase As Long) As Long
Public Declare Function wglUseFontOutlines Lib "opengl32" Alias "wglUseFontOutlinesA" (ByVal hdc As Long, ByVal first As Long, ByVal count As Long, ByVal listbase As Long, ByVal deviation As Single, ByVal extrusion As Single, ByVal format As Long, ByRef lpgmf As Any) As Long
' Kernel32
Public Declare Sub RtlMoveMemory Lib "kernel32" (Destination As Any, Source As Any, ByVal length As Long)
'***************************************************************************************
'*                                    Constantes                                       *
'***************************************************************************************
' Extensions
Private Const PAGE_EXECUTE_READWRITE = &H40&
' WGL (windows)
Public Const WGL_FONT_LINES = 0
Public Const WGL_FONT_POLYGONS = 1
' Glu32
Public Const GLU_INVALID_ENUM = 100900
Public Const GLU_INVALID_VALUE = 100901
Public Const GLU_OUT_OF_MEMORY = 100902
Public Const GLU_INCOMPATIBLE_GL_VERSION = 100903
Public Const GLU_VERSION = 100800
Public Const GLU_EXTENSIONS = 100801
Public Const GLU_TRUE = 1
Public Const GLU_FALSE = 0
Public Const GLU_SMOOTH = 100000
Public Const GLU_FLAT = 100001
Public Const GLU_NONE = 100002
Public Const GLU_POINT = 100010
Public Const GLU_LINE = 100011
Public Const GLU_FILL = 100012
Public Const GLU_SILHOUETTE = 100013
Public Const GLU_OUTSIDE = 100020
Public Const GLU_INSIDE = 100021
Public Const GLU_ERROR = 100103
Public Const GLU_TESS_MAX_COORD = 1E+150
Public Const GLU_TESS_WINDING_RULE = 100140
Public Const GLU_TESS_BOUNDARY_ONLY = 100141
Public Const GLU_TESS_TOLERANCE = 100142
Public Const GLU_TESS_WINDING_ODD = 100130
Public Const GLU_TESS_WINDING_NONZERO = 100131
Public Const GLU_TESS_WINDING_POSITIVE = 100132
Public Const GLU_TESS_WINDING_NEGATIVE = 100133
Public Const GLU_TESS_WINDING_ABS_GEQ_TWO = 100134
Public Const GLU_TESS_BEGIN = 100100
Public Const GLU_TESS_VERTEX = 100101
Public Const GLU_TESS_END = 100102
Public Const GLU_TESS_ERROR = 100103
Public Const GLU_TESS_EDGE_FLAG = 100104
Public Const GLU_TESS_COMBINE = 100105
Public Const GLU_TESS_BEGIN_DATA = 100106
Public Const GLU_TESS_VERTEX_DATA = 100107
Public Const GLU_TESS_END_DATA = 100108
Public Const GLU_TESS_ERROR_DATA = 100109
Public Const GLU_TESS_EDGE_FLAG_DATA = 100110
Public Const GLU_TESS_COMBINE_DATA = 100111
Public Const GLU_TESS_ERROR1 = 100151
Public Const GLU_TESS_ERROR2 = 100152
Public Const GLU_TESS_ERROR3 = 100153
Public Const GLU_TESS_ERROR4 = 100154
Public Const GLU_TESS_ERROR5 = 100155
Public Const GLU_TESS_ERROR6 = 100156
Public Const GLU_TESS_ERROR7 = 100157
Public Const GLU_TESS_ERROR8 = 100158
Public Const GLU_TESS_MISSING_BEGIN_POLYGON = GLU_TESS_ERROR1
Public Const GLU_TESS_MISSING_BEGIN_CONTOUR = GLU_TESS_ERROR2
Public Const GLU_TESS_MISSING_END_POLYGON = GLU_TESS_ERROR3
Public Const GLU_TESS_MISSING_END_CONTOUR = GLU_TESS_ERROR4
Public Const GLU_TESS_COORD_TOO_LARGE = GLU_TESS_ERROR5
Public Const GLU_TESS_NEED_COMBINE_CALLBACK = GLU_TESS_ERROR6
Public Const GLU_AUTO_LOAD_MATRIX = 100200
Public Const GLU_CULLING = 100201
Public Const GLU_SAMPLING_TOLERANCE = 100203
Public Const GLU_DISPLAY_MODE = 100204
Public Const GLU_PARAMETRIC_TOLERANCE = 100202
Public Const GLU_SAMPLING_METHOD = 100205
Public Const GLU_U_STEP = 100206
Public Const GLU_V_STEP = 100207
Public Const GLU_PATH_LENGTH = 100215
Public Const GLU_PARAMETRIC_ERROR = 100216
Public Const GLU_DOMAIN_DISTANCE = 100217
Public Const GLU_MAP1_TRIM_2 = 100210
Public Const GLU_MAP1_TRIM_3 = 100211
Public Const GLU_OUTLINE_POLYGON = 100240
Public Const GLU_OUTLINE_PATCH = 100241
Public Const GLU_NURBS_ERROR1 = 100251
Public Const GLU_NURBS_ERROR2 = 100252
Public Const GLU_NURBS_ERROR3 = 100253
Public Const GLU_NURBS_ERROR4 = 100254
Public Const GLU_NURBS_ERROR5 = 100255
Public Const GLU_NURBS_ERROR6 = 100256
Public Const GLU_NURBS_ERROR7 = 100257
Public Const GLU_NURBS_ERROR8 = 100258
Public Const GLU_NURBS_ERROR9 = 100259
Public Const GLU_NURBS_ERROR10 = 100260
Public Const GLU_NURBS_ERROR11 = 100261
Public Const GLU_NURBS_ERROR12 = 100262
Public Const GLU_NURBS_ERROR13 = 100263
Public Const GLU_NURBS_ERROR14 = 100264
Public Const GLU_NURBS_ERROR15 = 100265
Public Const GLU_NURBS_ERROR16 = 100266
Public Const GLU_NURBS_ERROR17 = 100267
Public Const GLU_NURBS_ERROR18 = 100268
Public Const GLU_NURBS_ERROR19 = 100269
Public Const GLU_NURBS_ERROR20 = 100270
Public Const GLU_NURBS_ERROR21 = 100271
Public Const GLU_NURBS_ERROR22 = 100272
Public Const GLU_NURBS_ERROR23 = 100273
Public Const GLU_NURBS_ERROR24 = 100274
Public Const GLU_NURBS_ERROR25 = 100275
Public Const GLU_NURBS_ERROR26 = 100276
Public Const GLU_NURBS_ERROR27 = 100277
Public Const GLU_NURBS_ERROR28 = 100278
Public Const GLU_NURBS_ERROR29 = 100279
Public Const GLU_NURBS_ERROR30 = 100280
Public Const GLU_NURBS_ERROR31 = 100281
Public Const GLU_NURBS_ERROR32 = 100282
Public Const GLU_NURBS_ERROR33 = 100283
Public Const GLU_NURBS_ERROR34 = 100284
Public Const GLU_NURBS_ERROR35 = 100285
Public Const GLU_NURBS_ERROR36 = 100286
Public Const GLU_NURBS_ERROR37 = 100287
Public Const GLU_CW = 100120
Public Const GLU_CCW = 100121
Public Const GLU_INTERIOR = 100122
Public Const GLU_EXTERIOR = 100123
Public Const GLU_UNKNOWN = 100124
Public Const GLU_BEGIN = GLU_TESS_BEGIN
Public Const GLU_VERTEX = GLU_TESS_VERTEX
Public Const GLU_END = GLU_TESS_END
Public Const GLU_EDGE_FLAG = GLU_TESS_EDGE_FLAG
' Gdi32
Public Const PFD_DRAW_TO_WINDOW = &H4&
Public Const PFD_DRAW_TO_BITMAP = &H8&
Public Const PFD_SUPPORT_GDI = &H10&
Public Const PFD_SUPPORT_OPENGL = &H20&
Public Const PFD_GENERIC_ACCELERATED = &H1000&
Public Const PFD_GENERIC_FORMAT = &H40&
Public Const PFD_NEED_PALETTE = &H80&
Public Const PFD_NEED_SYSTEM_PALETTE = &H100&
Public Const PFD_DOUBLEBUFFER = &H1&
Public Const PFD_STEREO = &H2&
Public Const PFD_SWAP_LAYER_BUFFERS = &H800&
Public Const PFD_DEPTH_DONTCARE = &H20000000
Public Const PFD_DOUBLEBUFFER_DONTCARE = &H40000000
Public Const PFD_STEREO_DONTCARE = &H80000000
Public Const PFD_SWAP_COPY = &H400
Public Const PFD_SWAP_EXCHANGE = &H200
Public Const PFD_TYPE_RGBA = 0
Public Const PFD_TYPE_COLORINDEX = 1
Public Const PFD_MAIN_PLANE = 0
Public Const PFD_OVERLAY_PLANE = 1
Public Const PFD_UNDERLAY_PLANE = (-1)

'***************************************************************************************
'*                                       Types                                         *
'***************************************************************************************
' Gdi32
Public Type PIXELFORMATDESCRIPTOR
    nSize As Integer
    nVersion As Integer
    dwFlags As Long
    iPixelType As Byte
    cColorBits As Byte
    cRedBits As Byte
    cRedShift  As Byte
    cGreenBits As Byte
    cGreenShift As Byte
    cBlueBits As Byte
    cBlueShift As Byte
    cAlphaBits As Byte
    cAlphaShift As Byte
    cAccumBits As Byte
    cAccumRedBits As Byte
    cAccumGreenBits As Byte
    cAccumBlueBits As Byte
    cAccumAlphaBits As Byte
    cDepthBits As Byte
    cStencilBits As Byte
    cAuxBuffers As Byte
    iLayerType As Byte
    bReserved As Byte
    dwLayerMask As Long
    dwVisibleMask As Long
    dwDamageMask As Long
End Type
Public Type POINTFLOAT
    x As Single
    y As Single
End Type
Public Type GLYPHMETRICSFLOAT
    gmfBlackBoxX As Single
    gmfBlackBoxY As Single
    gmfptGlyphOrigin As POINTFLOAT
    gmfCellIncX As Single
    gmfCellIncY As Single
End Type
' Autre
Public Type TColorub
    ColorRed As Byte
    ColorGreen As Byte
    ColorBlue As Byte
    ColorAlpha As Byte
End Type
Public Type TColorf
    ColorRed As Single
    ColorGreen As Single
    ColorBlue As Single
    ColorAlpha As Single
End Type
'***************************************************************************************
'*                            FONCTIONS SUPPLEMENTAIRES VB
'***************************************************************************************

' Recherche une chane de caractres d'aprs son pointeur
Public Function LongToString(pLong As Long) As String
    Dim lByte As Byte
    Dim lStr As String
    Dim lCpt As Long
On Error GoTo Gestion_Erreurs
    If pLong = 0 Then LongToString = "": Exit Function
    Do
        RtlMoveMemory lByte, ByVal pLong + lCpt, 1
        If lByte = 0 Then Exit Do
        lStr = lStr & Chr(lByte)
        lCpt = lCpt + 1
    Loop
    LongToString = lStr
Exit Function
Gestion_Erreurs:
    LongToString = ""
End Function
' Conversion de couleur VB en ub (byte)
Function ubColor(pColor As Long, Optional pAlpha As Byte = 255) As TColorub
Dim lbytes(1 To 4) As Byte
RtlMoveMemory lbytes(1), pColor, 4
lbytes(4) = pAlpha
ubColor.ColorAlpha = lbytes(4)
ubColor.ColorRed = lbytes(1)
ubColor.ColorGreen = lbytes(2)
ubColor.ColorBlue = lbytes(3)
End Function
' Conversion de couleur VB en f (single)
Function ufColor(pColor As Long, Optional pAlpha As Single = 1) As TColorf
Dim lbytes(1 To 4) As Byte
RtlMoveMemory lbytes(1), pColor, 4
lbytes(4) = pAlpha
ufColor.ColorAlpha = lbytes(4) / 255
ufColor.ColorRed = lbytes(1) / 255
ufColor.ColorGreen = lbytes(2) / 255
ufColor.ColorBlue = lbytes(3) / 255
End Function
' glColor adapt pour couleur VB
Public Function glColor3VB(pColor As Long)
Dim lbytes(1 To 3) As Byte
RtlMoveMemory lbytes(1), pColor, 4
glColor3ubv lbytes(1)
End Function
Public Function glColor4VB(pColor As Long, pAlpha As Byte)
Dim lbytes(1 To 4) As Byte
lbytes(4) = pAlpha
RtlMoveMemory lbytes(1), pColor, 4
glColor4ubv lbytes(1)
End Function
' Redirige les fonctions vers les extensions OpenGL
' Inspir de : http://www.activevb.de/tipps/vb6tipps/tipp0715.html
Public Sub RemapVBFunctionToGLFunction(ByVal pVBFuncAddr As Long, ByVal pGLFunction As String)
    Dim lProcAddress As Long
    Dim lVBProcAddress As Long
    Dim lOldProtect As Long
    Dim lRet As Long
    Dim lOldProtection As Long
    Dim lAsm(1 To 5)  As Byte
    Dim lJump As Long
    Const ASMSIZE = 5
    
    lProcAddress = wglGetProcAddress(ByVal pGLFunction)
    If lProcAddress = 0 Then lProcAddress = wglGetProcAddress(ByVal pGLFunction & "ARB")
    If lProcAddress = 0 Then lProcAddress = wglGetProcAddress(ByVal pGLFunction & "EXT")
    If lProcAddress <> 0 Then
        If IsRunningInIDE_DirtyTrick Then
            CopyMemory lVBProcAddress, ByVal pVBFuncAddr + 22, 4
        Else
            lVBProcAddress = pVBFuncAddr
        End If
        lRet = VirtualProtect(ByVal lVBProcAddress, ASMSIZE, PAGE_EXECUTE_READWRITE, lOldProtection)
        lJump = lProcAddress - lVBProcAddress - ASMSIZE
        lAsm(1) = &HE9
        CopyMemory lAsm(2), lJump, ASMSIZE - 1
        CopyMemory ByVal lVBProcAddress, lAsm(1), ASMSIZE
        lRet = VirtualProtect(ByVal lVBProcAddress, ASMSIZE, lOldProtection, 0&)
    End If
End Sub
' http://www.activevb.de/tipps/vb6tipps/tipp0347.html
Private Function IsRunningInIDE_DirtyTrick() As Boolean
  On Error GoTo NotCompiled
    Debug.Print 1 / 0
    Exit Function
NotCompiled:
    IsRunningInIDE_DirtyTrick = True
    Exit Function
End Function



